Subject: Re: Bonding problem

From: Jay Vosburgh <[email-masked]>
Date: Mon, 08 Aug 2011 10:06:05 -0700

Andy Gospodarek <[email-masked]> wrote:

>On Sun, Aug 07, 2011 at 03:00:30PM +0300, Eduard Sinelnikov wrote:
>> Hi,
>> 
>> In the kernel 2.6.39.3 ( /drivers/net/bond/bond_main.c).
>> In the function  ‘bond_xmit_roundrobin’
>> The code check if the bond is active via
>> ‘bond_is_active_slave(slave)’ Function call.
>> Which actually checks if the slave is backup or active
>> What is the meaning of slave being  backup in round robin mode?
>> Correct me if I wrong but in round robin every slave should send a
>> packet, regardless of being active or backup.
>> 
>> Thank you,
>>            Eduard
>
>There probably is not a compelling reason to continue to have it.  There
>may be a reason historically, but I'm not aware what that might be at
>this point.  For modes other than active-backup, the value of
>slave->link and slave->backup should always contain a value that
>indicates the slave is up and available for transmit.

	If you read Eduard's other posts regarding this, the actual
issue is that when changing from another mode into round-robin,
occasionally slaves will still be marked as "backup" and won't be used:

>Date: 	Mon, 8 Aug 2011 11:16:39 +0300
>Subject: On line Bonding configuration change fails
>From: Eduard Sinelnikov <[email-masked]>
>To: [email-masked]
>Sender: [email-masked]
>
>Hi,
>
>My configuration is a follows:
>
>             | eth0 -------------->
>Ububntu | eth1 -------------->    Swith ------------> Other computer
>
>Scenario:
>• change the bond mode to active/backup
>• unplug some of the cable
>• plug-in the unplugged cable
>• change bond mode to round robin
>
>I can see that only one eth1 is sending data. When I unplug it the ping stops.
>
>Is it a bug or some mis-configuration?
>
>In the kernel ( /drivers/net/bond/bond_main.c).
>In the function  ‘bond_xmit_roundrobin
>’
>The code check if the bond is active via
>‘bond_is_active_slave(slave)’ Function call.
>Which actually checks if the slave is backup or active
>What is the meaning of backup in round robin?
>Correct me if I wrong but in round robin every slave should send a
>packet, regardless of being active or backup.

	So from looking at the code, it seems that the actual problem is
that when transitioning to round-robin mode, one or more slaves can
remain marked as "backup," and in round-robin mode, that won't ever
change.  We could probably work around that by removing the "is_active"
test (essentially declaring that "is_active" is only valid in
active-backup mode).  That might produce a few odd messages here and
there (when removing a slave or during a link failure, for example).

	From inspection, the bond_xmit_xor function likely has this same
problem.

	-J

---
	-Jay Vosburgh, IBM Linux Technology Center, [email-masked]